/**
*ClamAV App
* There are different ways implementing an App
*/
var AntiVirusApp = AntiVirusApp || {};  //Define App namespace, if you want.
/**
*Constructor UNAS App
*/
AntiVirusApp.App = function () {
    this.id = 'AntiVirus';
    this.name = 'AntiVirus';
    this.version = '6.0.11';
    this.active = false;
    this.menuIcon = '/apps/antivirus/images/logo.png?v=6.0.11&';
    this.shortcutIcon = '/apps/antivirus/images/logo.png?v=6.0.11&';
    this.entryUrl = '/apps/antivirus/clamav_index.html?v=6.0.11&';
    var self = this;
    this.AntiVirusAppWindow = function () { //create app window
        if(UNAS.CheckAppState('AntiVirus')){
            return false;
        }
     self.window=new MUI.Window({
            id: 'AntiVirusAppWindow',
            title: UNAS._('AntiVirus'),
			icon: '/apps/antivirus/images/logo_small.png?v=6.0.11&',
            loadMethod: 'xhr',
            width: 1280,
            height: 728,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            resizeLimit: {
                'x': [800, 2500],
                'y': [500, 2000]
            },
            contentURL: '/apps/antivirus/clamav_index.html?v=6.0.11&',
            require: {
                css: ['/apps/antivirus/css/clamav.css']
            },
            onBeforeBuild: function () {
                UNAS.SetAppOpenedWindow("AntiVirus", 'AntiVirusAppWindow')
            },
        });
    };
    this.AntiVirusAppUninstall = function () {
        UNAS.RemoveDesktopShortcut('AntiVirus');
        UNAS.RemoveMenu('AntiVirus');
        UNAS.RemoveAppFromGroups('AntiVirus', 'ControlPanel');
        UNAS.RemoveAppFromGroups('AntiVirus', 'Help');
        UNAS.RemoveAppFromApps('AntiVirus');
    }

    new UNAS.Menu('UNAS_App_SystemTools_Menu', this.name, this.menuIcon, UNAS._('AntiVirus'), '', this.AntiVirusAppWindow);
    new UNAS.DesktopShortcut(this.name, this.shortcutIcon, UNAS._('AntiVirus'), this.AntiVirusAppWindow);
    // new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {'Type' : 'SystemTools', 'Location' : 6, "Icon": this.shortcutIcon, "Url": this.entryUrl},{});
    var OnChangeLanguage = function (e) {
        UNAS.SetMenuTitle('AntiVirus', UNAS._('AntiVirus')); //translate menu
        UNAS.SetShortcutTitle('AntiVirus', UNAS._('AntiVirus')); //translate shortcut
        if (typeof self.window !== 'undefined') {
            UNAS.SetWindowTitle('AntiVirusAppWindow', UNAS._('AntiVirus'));
        }
    }
    UNAS.LoadTranslation('/apps/antivirus/languages/Translation?v='+this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    UNAS.CreateApp(this.name,this.shortcutIcon,this.AntiVirusAppWindow,this.AntiVirusAppUninstall);
};

new AntiVirusApp.App(); //Create app
