var pretime = 0;
var timeScan = null;

//获取所有扫描任务  进入clamav scan 页面使用
function getClamavScanTaskList() {
  jQuery('#clamav_index_page_waiting_content').show();
  jQuery('#clamav_index_page_waiting_logo').show();
  clearTimeout(timeScan);
  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'antivirus_mission_alload'
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      var data = [];
      if (res.err == 0) {
        jQuery('#clamav_list').empty();
        var info = res.results || {};
        var i = 0;
        for (var v in info) {
          var t_ = info[v];
          var taskdom = clamTemplateAppend('#clamav_list', 'jvt-scanitem', 'jvt-scanitem-' + i)
          taskdom.data('taskinfo', t_);
          taskdom.find('.jvc-ff').text(t_.path).attr('title', t_.path);
          if (t_.type == 2) {
            taskdom.find('.jvc-ff').addClass('filetypeicon');
          } else {
            taskdom.find('.jvc-ff').addClass('foldertypeicon');
          }
          taskdom.find('.scantime').text(t_.lastscantime || '--');

          if (t_.lastscantime) {
            taskdom.find('.jvc-taskstate').text(UNAS._('Scan successful'));
          } else {
            taskdom.find('.jvc-taskstate').text(UNAS._('To be scanned'));
          }

          taskdom.find('.clamav_icon_start').data('taskinfo', t_);

          taskdom.find('.clamav_icon_start').on('click', function() {
            var info = jQuery(this).data('taskinfo');
            var scan = jQuery(this).attr('scan');
            if (scan == "scanning") {
              alert(UNAS._('Please wait for other scanning tasks to end!'));
              return;
            }
            startAllClamavScan(info.path, 'path');
          })

          taskdom.find('.clamav_icon_stop').on('click', function() {
            stopAllClamavScan();
          })
          taskdom.find('.clamav_icon_delete').data('taskinfo', t_);
          taskdom.find('.clamav_icon_delete').on('click', function() {
            var info = jQuery(this).data('taskinfo');
            deleteClamavScanTaskFn(info.msnno);
          })

          i++;
        }
      }

    },
    complete: function(xml) {
      jQuery('#clamav_index_page_waiting_content').hide();
      jQuery('#clamav_index_page_waiting_logo').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

jQuery('#clamav_task_search').keyup(function() {
  jQuery('#clamav_list tr').hide().filter(":contains('" + (jQuery(this).val()) + "')").show();
}).keyup();
jQuery('#clamav_task_search').keyup(function() {
  jQuery('#clamav_list tr').hide().filter(":contains('" + (jQuery(this).val()) + "')").show();
}).keyup();
//开始全盘扫描
function startAllClamavScan(path, type) {
  jQuery('#clamav_index_page_waiting_content').show();
  jQuery('#clamav_index_page_waiting_logo').show();

  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'antivirus_scan_start',
      "params": {
        path: path
      }
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {

      if (res.err == 0) {
        clearTimeout(timeScan);
        getClamavScanStatus();

      } else if (res.err == 9905) {
        alert('There is no quarantine zone, please configure it first!');
      } else {
        if (antivirus_errcode[res.err]) {
          alert(UNAS._(antivirus_errcode[res.err]));
        } else {
          alert(UNAS._('Operation failed!'));
        }
      }

    },
    complete: function(xml) {

      jQuery('#clamav_index_page_waiting_content').hide();
      jQuery('#clamav_index_page_waiting_logo').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}
//停止全盘扫描或者自定义扫描
function stopAllClamavScan() {
  jQuery('#clamav_index_page_waiting_content').show();
  jQuery('#clamav_index_page_waiting_logo').show();
  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'antivirus_scan_stop'
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(result) {
      getClamavScanStatus();
    },
    complete: function(xml) {
      jQuery('#clamav_index_page_waiting_content').hide();
      jQuery('#clamav_index_page_waiting_logo').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })

}
//扫描状态判断
function getClamavScanStatus() {
  clearTimeout(timeScan);
  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'antivirus_scan_running'
    }),
    dataType: "json",
    contentType: 'application/json',
    type: "post",
    async: true,
    timeout: 30000,
    success: function(data) {
      var info = data.results || {};
      jQuery('.jvc-allscans').text(info.scans || 0);
      jQuery('.jvc-scanfiletotal').text(info.total || 0);
      jQuery('.jvc-scaninfected').text(info.infectes || 0);
      var missions = info.missions || [];
      if (info.running) {
        jQuery(".clamav_scan_img").attr('class', "clamav_scan_img clamav_scan_running");

        jQuery(".clamav_scan_all").removeClass("unas_button_content");
        jQuery(".clamav_scan_all").addClass("unas_button_content_disabled");

        jQuery(".clamav_scan_custom").removeClass("unas_button_content");
        jQuery(".clamav_scan_custom").addClass("unas_button_content_disabled");

        jQuery(".clamav_scan_stop").show();

        jQuery(".clamav_scan_tips1").hide();
        jQuery(".clamav_scan_tips2").hide();
        jQuery(".clamav_scan_tips3").show();
        jQuery(".clamav_scan_tips4").hide();


        var allpercentage = parseInt(info.percentage) || 0;
        if (allpercentage >= 100) {
          allpercentage = 100;
        }
        jQuery('#jv-percentage').text("（" + allpercentage + "%" + "）");
        jQuery('.clamav_scan_tips4_files').text(info.currfile || '');

        var tasklist = jQuery('#clamav_list tr');

        for (var i = 0; i < tasklist.length; i++) {
          var t_ = tasklist[i];
          var taskinfo = jQuery(t_).data('taskinfo');
          if (taskinfo.path == info.path) {
            jQuery(t_).find('.clamav_icon_start').addClass('hide');
            jQuery(t_).find('.clamav_icon_stop').removeClass('hide');
            jQuery(t_).find('.clamav_icon_delete').addClass('disableddelbtn');
            jQuery(t_).find('.scantime').hide();
            jQuery(t_).find('.meter').show();
            var percentage = parseInt(info.percentage) || 0;
            if (percentage >= 100) {
              percentage = 100;
            }
            jQuery(t_).find('.scanprotxt').text(percentage + '%');
            jQuery(t_).find('.scanpro_bar').css('width', percentage + '%');
            jQuery(t_).find('.jvc-taskstate').text(UNAS._('Scanning ...'));
            continue;
          } else {
            for (var v in missions) {
              if (missions.hasOwnProperty(v)) {
                if (taskinfo.path == missions[v].path) {
                  jQuery(t_).find('.scantime').text(missions[v].lastscantime || '--');
                }
              }
            }

            jQuery(t_).find('.clamav_icon_start').removeClass('hide').attr('scan', 'scanning');
            jQuery(t_).find('.clamav_icon_start').addClass('disabledbtn');
            jQuery(t_).find('.clamav_icon_stop').addClass('hide');
            jQuery(t_).find('.clamav_icon_delete').addClass('disableddelbtn');

            if (jQuery(t_).find('.scantime').text() == '--' || !jQuery(t_).find('.scantime').text()) {
              jQuery(t_).find('.jvc-taskstate').text(UNAS._('To be scanned'));
            } else {
              jQuery(t_).find('.jvc-taskstate').text(UNAS._('Scan successful'));
            }

            jQuery(t_).find('.meter').hide();
            jQuery(t_).find('.scantime').show();
          }
        }

      } else {

        jQuery(".clamav_scan_all").removeClass("unas_button_content_disabled");
        jQuery(".clamav_scan_all").addClass("unas_button_content");

        jQuery(".clamav_scan_custom").removeClass("unas_button_content_disabled");
        jQuery(".clamav_scan_custom").addClass("unas_button_content");

        jQuery(".clamav_scan_stop").hide();

        if (info.endtime) {
          jQuery('.jvc-lastscantime').text(info.endtime);
          if (info.infectes) {
            jQuery(".clamav_scan_tips2").show();
            jQuery(".clamav_scan_tips1").hide();
            jQuery(".clamav_scan_tips3").hide();
            jQuery(".clamav_scan_tips4").hide();
            jQuery(".clamav_scan_img").attr('class', "clamav_scan_img clamav_scan_warn");
          } else {
            jQuery(".clamav_scan_tips1").show();
            jQuery(".clamav_scan_tips2").hide();
            jQuery(".clamav_scan_tips3").hide();
            jQuery(".clamav_scan_tips4").hide();
            jQuery(".clamav_scan_img").attr('class', "clamav_scan_img clamav_scan_complete");
          }

        } else {
          jQuery(".clamav_scan_tips4").show();
          jQuery(".clamav_scan_tips2").hide();
          jQuery(".clamav_scan_tips3").hide();
          jQuery(".clamav_scan_tips1").hide();
          jQuery(".clamav_scan_img").attr('class', "clamav_scan_img clamav_scan_nostart");
        }

        var tasklist = jQuery('#clamav_list tr');

        for (var i = 0; i < tasklist.length; i++) {
          var t_ = tasklist[i];
          var taskinfo = jQuery(t_).data('taskinfo');
          jQuery(t_).find('.clamav_icon_start').removeClass('hide').attr('scan', '');
          jQuery(t_).find('.clamav_icon_start').removeClass('disabledbtn');
          jQuery(t_).find('.clamav_icon_stop').addClass('hide');
          jQuery(t_).find('.clamav_icon_delete').removeClass('disableddelbtn');

          for (var v in missions) {
            if (missions.hasOwnProperty(v)) {
              if (taskinfo.path == missions[v].path) {
                jQuery(t_).find('.scantime').text(missions[v].lastscantime || '--');
              }
            }
          }

          if (jQuery(t_).find('.scantime').text() == '--' || !jQuery(t_).find('.scantime').text()) {
            jQuery(t_).find('.jvc-taskstate').text(UNAS._('To be scanned'));
          } else {
            jQuery(t_).find('.jvc-taskstate').text(UNAS._('Scan successful'));
          }

          jQuery(t_).find('.scantime').show();
          jQuery(t_).find('.meter').hide();
          jQuery(t_).find('.scanprotxt').text('0%');
          jQuery(t_).find('.scanpro_bar').css('width', '0%');
        }

      }
    },
    complete: function() {

      if (jQuery(".clamav_scan_page").length > 0) {
        timeScan = setTimeout(function() {
          getClamavScanStatus();
        }, 2000);
      } else {
        clearTimeout(timeScan);
      }

    }
  });

}

//添加扫描任务
function addFileOrFolder() {
  var cwh = getClientWH();
  var addFileOrFolderWindow = new MUI.Modal({
    id: 'addFileOrFolderWin',
    title: UNAS._('Add File/Folder'),
    modal: true,
    width: cwh.w,
    height: cwh.h,
    addClass:'mobile-modal',
    type: 'modal2',
    modalOverlayClose: false,
    contentURL: '/apps/antivirus/m/add_file_folder.html?v=6.0.11&'
  });

}

function deleteClamavScanTaskFn(taskname) {
  var cwh = getClientWH();
  var deleteClamavScanTaskWin = new MUI.Modal({
    id: 'deleteClamavWindow',
    title: UNAS._('ClamAV Delete Scan Task'),
    modal: true,
    width: parseInt(cwh.w * 0.88),
    height: 200, //+50
    addClass:'delete-modal',
    modalOverlayClose: false,
    data: {
      path: taskname
    },
    contentURL: '/apps/antivirus/m/clamav_deletetask.html?v=6.0.11'
  });
  deleteClamavScanTaskWin.callback = function() {
    //刷新任务列表
    getClamavScanTaskList();
  }
}



function switchscan_sub(type) {
  var enevt = window.enevt || arguments.callee.caller.arguments[0];
  var that = enevt.currentTarget;
  jQuery(that).addClass('cur-nav').removeClass('sel-nav')
  jQuery(that).siblings().addClass('sel-nav').removeClass('cur-nav');
  jQuery('.jvc-scantype').hide();
  jQuery('#jv-' + type).show();
}

(function() {
  getClamavScanStatus();

  if (daemonstate) {
    jQuery('#jv-clamavscanop').removeClass('disabledbtn');
    jQuery('#clamav_list').removeClass('disabledbtn');
  } else {
    jQuery('#jv-clamavscanop').addClass('disabledbtn');
    jQuery('#clamav_list').addClass('disabledbtn');
  }

})();
